* Program :APRINT.PRG For Clipper 5.2c
*--------------------------------------------------------------------
* Author       : Jean-Claude CAROW  Compuserve 100445,1310
* Date created : 01/24/94
* Copyright    : JCC.LIB Jean-Claude CAROW
*--------------------------------------------------------------------
* Function     : Aprint(aEntete,aTitre_Col,aTableau) -->prints table (array)
* Usage        : Prints table (Array) with frame in 80 or 136 columns
*                automatically
*
* Arguments    : <aEntete>    general title of the table
*              : <aTitre_Col> each column title of the table
*              : <aTableau>   multi-dimensional array
* Return Value : None, prints the array on printer (compatible EPSON)
*--------------------------------------------------------------------
* I hope you find this program useful. Please send your comment by E-mail
* on my work.
*
* Thanks - Jean-Claude CAROW

#include 'couleur.ch'
#include 'printer.ch'

Procedure aPrint (aEntete,aTitre_Col,aTableau)
// imprime un tableau avec encadrement de traits
Local Dim_Tableau:=0
local i:=j:=1,s_ecran,tab
Local Saut_Page:=Long_Ligne:=0
Local temp:='',set_lp

Dim_Tableau:=len(aTitre_Col) //Nombre de colonnes du tableau
      FOR i:=1 to Dim_Tableau
          Long_ligne:=Long_ligne+len(aTableau[1,i])
      NEXT I
          Long_Ligne:=Long_Ligne+Dim_Tableau+1

              IF Long_Ligne>80
                 Long_Ligne:=136
                 Set_lp:=COND
              ELSE
                 Long_Ligne:=80
                 Set_lp:=NORM
              ENDIF
     IF Prn_ok()
        S_Ecran=SaveScreen(11,25,19,55)
        Printcodes(set_lp)
        Set printer on
        Set console off
          FOR I:=1 to len(aEntete)
          ? PADC(aEntete[i],Long_Ligne)
          NEXT
          ?
          Saut_Page:=Saut_Page+i

// Trac de cadre avant titres
FOR i:=1 to len(aTitre_Col)
    IF i=1
       temp:=''+replicate('',len(aTableau[1,i]))
    ELSE
       temp:=temp+replicate('',len(aTableau[1,i]))
    ENDIF

         IF i=len(aTitre_Col)
            temp:=temp+''
         ELSE
             temp:=temp+''
         ENDIF
NEXT
? padc(temp,long_ligne) // Imprime 1er trait
temp:=''

// impression des titres de colonnes du tableau
   FOR i:=1 to len(aTitre_Col)-1
    IF i=1
      Temp:=''+aTitre_Col[i]+space(len(aTableau[1,i])-len(aTitre_Col[i]))+''
    ELSE
      Temp:=Temp+aTitre_Col[i]+space(len(aTableau[1,i])-len(aTitre_Col[i]))+''
    ENDIF
   NEXT I
      Temp:=Temp+aTitre_Col[i]+space(len(aTableau[1,i])-len(aTitre_Col[i]))+''

? PADC(Temp,Long_Ligne) // Impression des titres

FOR i:=1 to len(aTitre_Col)
    IF i=1
       temp:=''+replicate('',len(aTableau[1,i]))
    ELSE
       temp:=temp+replicate('',len(aTableau[1,i]))
    ENDIF

        IF i=len(aTitre_Col)
           temp:=temp+''
        ELSE
           temp:=temp+''
        ENDIF
NEXT
? padc(temp,long_ligne) // Trac du trait sous les titres du tableau
//?;?
Temp:=''

// Impression et trac des valeurs du tableau
Saut_Page:=Saut_Page+3
   FOR i:=1 to len(aTableau)

       FOR J:=1 to Dim_Tableau-1
             IF j=1
                   Temp:=''+aTableau[i,j]+''
             ELSE
                   Temp:=temp+aTableau[i,j]+''
             ENDIF
       NEXT J // J en sortie de boucle est  len(aTableau)+1

      Temp:=Temp+aTableau[i,j]+''

            ? PADC(Temp,Long_Ligne)
            Temp:=""
            Saut_page++
                  IF Saut_Page>56
                      Saut_page:=0
                      Eject
                  ENDIF
   NEXT I

// Trac de cadre aprs titres
FOR i:=1 to len(aTitre_Col)
    IF i=1
       temp:=''+replicate('',len(aTableau[1,i]))
    ELSE
       temp:=temp+replicate('',len(aTableau[1,i]))
    ENDIF

         IF i=len(aTitre_Col)
            temp:=temp+''
         ELSE
             temp:=temp+''
         ENDIF
NEXT
? padc(temp,long_ligne) // Imprime dernier trait
temp:=''

Eject
Printcodes(NORM)
Set printer off
RestScreen(11,25,19,55,S_Ecran)
     ENDIF
RETURN


FUNCTION PRN_OK()
local Key:=79,S_Ecran
set cursor off
S_Ecran=SaveScreen(12,23,19,53)
DO WHILE chr(Key)!='n' .and. chr(Key)!='N'
   IF .not. isprinter()
      boite(12,23,18,51,c_alerte,"double",.T.)
      @ 14,27 say 'Imprimante non prte !'
      @ 16,27 say 'Un autre essai ? (O/N)'
      Key:=inkey(0)
     ELSe
         setcolor(ccouleur)
         RestScreen(12,23,19,53,S_Ecran)
         return(.T.)
    ENDIF
ENDDO
RestScreen(12,23,19,53,S_Ecran)
setcolor(ccouleur)
return(.F.)

